//--------------------------------------------------------------------------
#include <vcl.h>
#include <list.h>
#pragma hdrstop

#include "main.h"
#include "Unit1.h"
#include "repere.h"
#include "box.h"
#include "interval.h"
#include <fstream>
#include "Unit1.h"

int dimp=2;
int N_bissect=0;


//---------------------------------------------------------------------------
#pragma package(smart_init)
//----------------------------------------------------------------------
extern TForm1 *Form1;
fstream Fout;
double eps=0.04;
//----------------------------------------------------------------------
void Draw_data(repere& R,double p1, double p2)
{  for (double k=0;k<Form1->m;k=k+0.1)
    { double t=(k+1)*Form1->dt;
      box Q(2);
      Q[1]=Form1->T[k];
      if (Form1->model==1)
         Q[2]=p1*sin(p2*t)+interval(-0.001,0.001);
      else
         Q[2]=p1*exp(p2*t)+interval(-0.001,0.001);
      R.DrawBox(Q,clBlack,clBlack,bsSolid);
    }
    R.image->Refresh();

} ;
//----------------------------------------------------------------------
bool Contract_Modele_a(box& P)  //modele a : y=p1*sin(p2*t);
{   vector<box> L;
    box Pi;
    for  (int k=0;k<Form1->m;k++)
     	{       double t=Center(Form1->T[k]);
                Pi=P;
                if (Form1->model==1)
                {
                        interval S(-1,1);
                        interval P2T=t*Pi[2];
                        Csin(S,P2T,1);
                        interval Y1=Form1->Y[k];
                        Cprod(Y1,Pi[1],S,1);
                        Cprod(Y1,Pi[1],S,-1);
                        Csin(S,P2T,-1);
                        Cprod(P2T, t, Pi[2],-1);
                }
                else
                {
                        interval S(-1000,1000);
                        interval P2T=t*Pi[2];
                        Cexp(S,P2T,1);
                        interval Y1=Form1->Y[k];
                        Cprod(Y1,Pi[1],S,1);
                        Cprod(Y1,Pi[1],S,-1);
                        Cexp(S,P2T,-1);
                        Cprod(P2T, t, Pi[2],-1);
                }

                L.push_back(Pi);
        }   ;
     C_q_in(P,Form1->m-Form1->q,L);
}


void SIVIA(box& P0)
{   box P;
    Form1->R1.image->Refresh();
    list<box> L;
    L.push_back(P0);
    while (!L.empty())
    { P=L.front();
      Form1->R1.DrawCadre(P,clLtGray,psSolid,1,2,1);
      L.pop_front();
      bool sortie=false;
      while (!sortie)
       {  box Pold(P);
          Contract_Modele_a(P);
          if (P.IsEmpty())           sortie=true;
          if (decrease(Pold,P)<0.03) sortie=true;
       }
      if (!P.IsEmpty())
      {  if (P.Width()<eps)
            {     Form1->R1.DrawBox(P,clBlack,clBlack,bsSolid,1,2);
                  Draw_data(Form1->R2,Center(P[1]),Center(P[2]));
                  Form1->R2.image->Refresh();
            }
         else  {   box P1,P2;
                   Bisect(P,P1,P2);
                    Fout << "P = " <<P<<"\n";
                   N_bissect++;
                   L.push_back(P1);
                   L.push_back(P2);
               }
      }
    }
    L.clear();
} ;



//----------------------------------------------------------------------
void TForm1::GO_SIVIA()
{ Fout.open("info.txt",fstream::out);
  Fout <<"Dbut\n"<<"\n";

  box P(2);
  P[1]=interval(Form1->p1min,Form1->p1max);
  P[2]=interval(Form1->p2min,Form1->p2max);
  SIVIA(P);
  Fout << "N_bissect = " <<N_bissect<<"\n";
  Fout.close();
} ;

//----------------------------------------------------------------------

//----------------------------------------------------------------------
void TForm1::GO_MC()
{ Fout.open("info.txt",fstream::out);
  Fout <<"Dbut\n"<<"\n";


  box P(2);
  P[1]=interval(Form1->p1min,Form1->p1max);
  P[2]=interval(Form1->p2min,Form1->p2max);

  for (int k=1;k<=10000;k++)
  {
      box Q=Rand(P);
      box Q1=Inflate(Q, 0.02);
      box Q2=Inflate(Q, 0.00001);
//      Form1->R1.DrawBox(Q1,clBlack,clBlack,bsSolid,1,2);

      Contract_Modele_a(Q2);
      if (!(Q2.IsEmpty()))
         {        Draw_data(Form1->R2,Center(Q[1]),Center(Q[2]));
                  Form1->R2.image->Refresh();
                  Form1->R1.DrawBox(Q1,clBlack,clBlack,bsSolid,1,2);
         };
      Form1->R1.image->Refresh();
  }
  Fout.close();
} ;

//----------------------------------------------------------------------
