//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include "box.h"
#include "repere.h"
#include "main.h"
#include "iboolean.h"
#include <ComCtrls.hpp>

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// Composants grs par l'EDI
        TButton *Button_Estim_a;
        TImage *Image1;
        TImage *Image2;
        TTrackBar *TrackBar_q;
        TButton *Button2;
        TMemo *Memo1;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TTrackBar *TrackBar_prob_a;
        TTrackBar *TrackBar_prob_b;
        TButton *Button_Estim_b;
        TRadioGroup *RadioGroup1;
        void __fastcall Button_Estim_aClick(TObject *Sender);
        void __fastcall Button2Click(TObject *Sender);
        void __fastcall TrackBar_qChange(TObject *Sender);
        void __fastcall TrackBar_prob_aChange(TObject *Sender);
        void __fastcall TrackBar_prob_bChange(TObject *Sender);
        void __fastcall Button_Estim_bClick(TObject *Sender);
private:	// Dclarations utilisateur
public:		// Dclarations utilisateur
        __fastcall TForm1(TComponent* Owner);
        void TForm1::GO_SIVIA();
        void TForm1::GO_MC();
        repere R1,R2;
        double tmin,tmax,ymin,ymax,p1min,p1max,p2min,p2max;

        vector <interval> T;
        vector <interval> Y;
        int m,q;
        int data_generated;
        double emax,dt,prob_a,prob_b,pfp_a,pfp_b,model;
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
